=== debian/changelog ===
gammaray (2.1.0-3) unstable; urgency=medium

  * Team upload.

  [ Jakub Adam ]
  * Force 24-bit color depth to Xvfb
    - attempts to fix "Unsupported screen depth: 8" failures during
      the test runs on some architectures.

  [ Felix Geyer ]
  * Fix FTBFS on mips64 kernel, ppc64 and arm64.
  * Make testsuite non-fatal on kfreebsd due to bug #570805:
    Wrong path in /proc/pid/maps when bind mounted.
  * Run tests sequentially in the hope that it helps running them on
    architectures with low resources.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 27 Jul 2014 17:22:50 +0200

gammaray (2.1.0-2) unstable; urgency=medium

  * Fix FTBFS on kFreeBSD, Hurd, mips, ppc, and s390x (Closes: #754986).

 -- Jakub Adam <jakub.adam@ktknet.cz>  Fri, 18 Jul 2014 18:26:51 +0200

gammaray (2.1.0-1) unstable; urgency=medium

  [ Felix Geyer ]
  * Call dh_auto_clean for both build directories.

  [ Jakub Adam ]
  * New upstream release.
  * Removed no longer needed use-empty-rpath.patch.
  * Build-depend on qtdeclarative5-private-dev.
  * Create gammaray-plugin-quickinspector binary package.
  * Removed unused license paragraph from d/copyright.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Mon, 07 Jul 2014 21:38:05 +0200

gammaray (2.0.2-1) unstable; urgency=medium

  [ Jakub Adam ]
  * New upstream release.
  * Re-enable tests in Qt5 build.

  [ Felix Geyer ]
  * Make gammaray-dev depend on gammaray-probe-qt4 to fix broken symlinks.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Tue, 06 May 2014 23:01:05 +0200
