=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_installdocs override_dh_strip override_dh_clean

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	# Move away bundled Qt private headers so that system versions are used
	if [ -d 3rdparty/qt/private ]; then \
		mv 3rdparty/qt/private 3rdparty/qt/private.dont.use; \
	fi

	dh_auto_configure -B obj-qt5
	dh_auto_configure -B obj-qt4 -- -DGAMMARAY_ENFORCE_QT4_BUILD=ON -DGAMMARAY_PROBE_ONLY_BUILD=ON

override_dh_auto_build:
	dh_auto_build -B obj-qt5 -O--parallel
	dh_auto_build -B obj-qt4 -O--parallel

override_dh_auto_test:
# tests fail on kfreebsd because of bug #570805: Wrong path in /proc/pid/maps when bind mounted
ifneq (,$(filter $(DEB_HOST_ARCH), kfreebsd-amd64 kfreebsd-i386))
	xvfb-run -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -B obj-qt5 || true
else
	xvfb-run -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -B obj-qt5
endif

override_dh_auto_install:
	dh_auto_install -B obj-qt5
	dh_auto_install -B obj-qt4
	rm -f debian/tmp/usr/share/doc/gammaray/License.txt

override_dh_auto_clean:
	dh_auto_clean -B obj-qt5
	dh_auto_clean -B obj-qt4

override_dh_installdocs:
	dh_installdocs --link-doc=gammaray

override_dh_strip:
	dh_strip --dbg-package=gammaray-dbg

override_dh_clean:
	dh_clean

	# Put back bundled Qt private headers to restore sources into original state
	if [ -d 3rdparty/qt/private.dont.use ]; then \
		mv 3rdparty/qt/private.dont.use 3rdparty/qt/private; \
	fi
