=== debian/watch ===
version=3
http://githubredir.debian.net/github/KDAB/GammaRay /v(.*).tar.gz
